----------------------------
----------------------------
---- Playing Cards Code ----
----------Deck.lua----------
----------------------------


--require(Constants);


Deck = {};
Deck.VERSION 	= 0.1
Deck.DEBUG 		= false;
Deck.inited 	= false;
Deck.cards 		= {};

--print("Running Deck.VERSION= " .. tostring(Deck.VERSION))
--**********************************************************************
--Deck.Init()
--@desc: 	Initialises the static class.
--@return: 	nil
--optionals

function Deck.Init()
	--Initialise, and pass through arguments.
	
	--SUIT and NUMBER are tables in Constants
	for i = 1, #SUIT do
		for j = 1, #NUMBER do
			table.insert(Deck.cards, Card.Create(SUIT[i], NUMBER[j] ));
			--Card.Print(Deck.cards[((i-1)*13)+j]);
		end
	end
	
	--once inited completed, set to true
	Deck.inited = true;
end

--Deck.DeInit()
--@desc:	Removes the table entries of Deck.cards
--@desc:	and resets the table. The table is then empty.
--@return:	nil
function Deck.DeInit()
	
	for i = 1, #Deck.cards do
		table.remove(Deck.cards[i]);
	end
	
	Deck.cards = {};
	
	--once deinited, set to false
	Deck.inited = false;
end

--Deck.DealCard()
--@desc:	Takes the last card in Deck.cards into a 
--@desc:	local variable ChosenCard. It then removes
--@desc:	the last entry from Deck.cards and returns
--@desc:	ChosenCard. 
--@return:	ChosenCard.
function Deck.DealCard()
	local ChosenCard = Deck.cards[#Deck.cards];
	
	table.remove(Deck.cards);
	
	return ChosenCard;
end

--Deck.Shuffle()
--@desc:	The table Deck.cards is copied into local
--@desc:	variable deck. A For loop, starting at the
--@desc:	end of deck and counting backwards. Another
--@desc:	local variable, rand, is created containing
--@desc:	a random number between 1 and i. The actual
--@desc:	takes deck[i] and deck[rand] and swaps them
--@desc:	with each other. It does this for every
--@desc:	step of the for loop. Deck is then returned
--@return:	deck
function Deck.Shuffle()
	
	local deck = Deck.cards;
	
	-- FisherYates shuffle, counts backwards
	for i = #deck, 1, -1 do
		local rand = math.random(1, i);
		
		--The SHUFFLE!!
		deck[i], deck[rand] = deck[rand], deck[i];
	end
	
	return deck;
end