----------------------------
----------------------------
---- Playing Cards Code ----
---------Player.lua---------
----------------------------

Player = {};

--Player.Create()
--@param:	Name
--@desc: 	Creates a new instace of this object.
--@return: 	the new instance.
function Player.Create(Name)
	local player_obj = {};
	--assign any default vars
	player_obj.name 	= Name;
	player_obj.hand		= {};

	--assign functions (yeah this bit sucks compared to other languages... but lua really isn't OO... le sigh)
	player_obj.ShowCards= Player.ShowCards;
	player_obj.AddToHand= Player.AddToHand;
	player_obj.Input	= Player.Input;
	
	return player_obj;
end

--Player.ShowCards()
--@param:	self
--@desc:	Prints out the Player's Hand
--@desc:	A For Loop to call Card.Print, which prints
--@desc:	Cards out one by one. It does this for every
--@desc:	Card Object in Player.hand.
--@return:	nil
function Player.ShowCards(self)
	print(self.name.."'s Hand { ");
	
	for i = 1, #self.hand do
		Card.Print(self.hand[i]);
	end
	
	print("}");
end

--Player.AddToHand()
--@param:	self
--@param:	card_obj
--@desc:	Takes in a self argument (Player Object)
--@desc:	and a card_obj (Card Object) argument to 
--@desc:	add the last entry in the Deck.cards table
--@desc:	to the Player.hand table.
--@return:	nil
function Player.AddToHand(self, card_obj)
	
	table.insert(self.hand, card_obj);	
end

--[[Rewrite to take in # of cards user wants per hand
--Player.Input()
--@param:	cardpile
--@desc:	This function takes the input from the user
--@desc:	and compares it to enums created in the 
--@desc:	Constants class. The enums represent card 
--@desc:	attributes and are numbered 1-4. Depending 
--@desc:	on the input, respective card attributed are 
--@desc:	returned. A while loop, has been put in place
--@desc:	to catch any bad or unusable inputs.
--@return:	userin - this is a local variable that holds
--@return:	the card attribute. 
function Player.Input(cardpile)

	print("Select a card stat, 1-4, and enter that value");
	
	--Reading in the user's choice (a number)
	local readin = read("*n");

	local userin = nil;
	
	if( readin ~= nil ) then
		--Lua doesn't have switch cases, this makes me a saaaad panda
		if( readin == OFFENCE_ID ) then
			userin = OFFENCE_ID;
		elseif( readin == DEFENCE_ID ) then
			userin = DEFENCE_ID;
		elseif( readin == POWER_ID ) then
			userin = POWER_ID;
		elseif( readin == SPEED_ID ) then
			userin = SPEED_ID;
		else
			while readin ~= OFFENCE_ID and readin ~= DEFENCE_ID and readin ~= POWER_ID and readin ~= SPEED_ID do
				print("Please enter a number between 1 and 4");
			end
		end 
	end

	return userin;
end
]]


