----------------------------
----------------------------
---- Playing Cards Code ----
----------------------------
----------------------------

--Loading in other objects and classes
require("Deck");
require("Constants");
require("Player");
require("Card");
require("RuleBook");

--Global variables
GLOBAL_VARS = {};
GLOBAL_VARS.Player1Store= Player.Create("Joe"); --Variable used to store the Player object
GLOBAL_VARS.Player2Store= Player.Create("Player 2");
GLOBAL_VARS.MaxHand		= 8; --Maximum amount of cards Player.Hand can hold
GLOBAL_VARS.CardPile	= {};

--BuildHand()
--@desc:	This function works by using a for loop to deal a card
--@desc:	into a local variable, then copy the contents of that 
--@desc:	local variable (a playing card) to the Player.hand table.
--@desc:	I've set it up to deal the cards one at a time to each player.
--@return:	nil
function BuildHand()
	local cardStore = nil;
	
	for i = 1, GLOBAL_VARS.MaxHand do
		
		cardStore = Deck.DealCard();
			
		Player.AddToHand(GLOBAL_VARS.Player1Store, cardStore);
		
		cardStore = Deck.DealCard();
		
		Player.AddToHand(GLOBAL_VARS.Player2Store, cardStore);
		
	end
	
	Player.ShowCards(GLOBAL_VARS.Player1Store);
	Player.ShowCards(GLOBAL_VARS.Player2Store);
end

--PrintCardPile()
--@desc:	This will print out all the cards in the CardPile
--@desc:	table when this file is run in Command Prompt
--@desc:	This is mainly for debugging.
function PrintCardPile(cardpile)
	
	local Pile = #cardpile;
	
	for i = 1, Pile do
		Card.Print(cardpile);
	end
end

--table.foreach(Deck.cards, print);

--[[Rewrite to link up with Player.Input() and take in # 
--	of cards user wants per hand
--ReadInputAndCompare()
--@param:	player1
--@param:	player2
--@param:	cardpile
--@desc:	This function takes in the player global vars
--@desc:	and the global table CardPile. Local var 'a'
--@desc:	takes a return from Player.Input, the function
--@desc:	that reads in a player input and returns it as
--@desc: 	a card stat. The paramaters are then passed into
--@desc:	RuleBook.StatComp() for comparison. 
function ReadInputAndCompare(player1, player2, cardpile)
	
	local cardStat = Player.Input(cardpile);	
	local cardStat2 = nil;

	if( cardStat == OFFENCE_ID ) then
		cardStat = cardpile[1].Offence;
		cardStat2 = cardpile[2].Offence;
	elseif( cardStat == DEFENCE_ID ) then
		cardStat = cardpile[1].Defence;
		cardStat2 = cardpile[2].Defence;	
	elseif( cardStat == POWER_ID ) then
		cardStat = cardpile[1].Power;
		cardStat2 = cardpile[2].Power;	
	elseif( cardStat == SPEED_ID ) then
		cardStat = cardpile[1].Speed;
		cardStat2 = cardpile[2].Speed;
	end
	
	if( RuleBook.Turn == player1 ) then
				
		print(player1.." has chosen "..cardStat);
		
	elseif( RuleBook.Turn == player2 ) then
		
		print(player2.." has chosen "..cardStat);
	end
	
	RuleBook.StatComp(cardStat, cardStat2, player1, player2, cardpile);
	
end
]]
--Calling Functions
Deck.Init();
BuildHand();

--RuleBook.PlayerTurn(GLOBAL_VARS.Player1Store, GLOBAL_VARS.Player2Store, GLOBAL_VARS.CardPile)

